﻿using UnityEngine;
using System.Collections;

[RequireComponent( typeof( SteamVR_TrackedObject ) )]
public class Sword : MonoBehaviour
{
    private SteamVR_TrackedObject trackedObject;

    private SteamVR_Controller.Device Controller
    {
        get
        {
            return SteamVR_Controller.Input( ( int )this.trackedObject.index );
        }
    }

    void Start()
    {
        this.trackedObject = this.GetComponentInParent<SteamVR_TrackedObject>();
    }

    void OnCollisionEnter( Collision collision )
    {
        // Destroy targets that we collide with, but only if we're moving fast enough:
        Target target = collision.collider.GetComponent<Target>();
        if ( target != null && target.DestroyedBySword && this.Controller.velocity.magnitude > 1.0f )
        {
            this.StartCoroutine( this.TargetDestroyedHapicPulse() );
            target.PlayDestroyEffect( true );
            GameObject.Destroy( target.gameObject );
            GameStateManager.Instance.IncreaseScore();
        }
    }

    IEnumerator TargetDestroyedHapicPulse()
    {
        this.Controller.TriggerHapticPulse( 1000 );
        yield return new WaitForSeconds( 0.01f );
        this.Controller.TriggerHapticPulse( 1000 );
        yield return new WaitForSeconds( 0.01f );
        this.Controller.TriggerHapticPulse( 1000 );
        yield return new WaitForSeconds( 0.01f );
    }
}
